require 'object_spy/version'
require 'fozzie'
require 'object_spy/rack/middleware'

module ObjectSpy

  def self.adapter(adp = nil)
    @adapter = adp if adp
    @adapter || ::Stats
  end

  def self.spy
    default_spy_proc.call
  end

  private

  def self.default_spy_proc
    @default_spy_proc ||= Proc.new do
      adapter.bulk do
        ObjectSpace.count_objects.each do |type,count|
          gauge type.to_s, count
        end
        gauge 'symbol_count', Symbol.all_symbols.size
      end
    end
  end
end
