module ObjectSpy
  module Rack
    class Middleware

      attr_reader :app

      def initialize(app)
        @app = app
      end

      def call(env)
        res = @app.call(env)
        send_object_stats(env)
        res
      end

      private

      def send_object_stats(env)
        ObjectSpy.spy
      rescue => exc
        env['rack.errors'].write(exc.message)
      end

    end
  end
end
